Reorganize 3D View Menus: View, Add and Object Menu
Closed, ArchivedPublic

Description

Moved to D2876

Julian Eisel (Severin) renamed this task from space_view_3d_patch View Menu, Add Menu, Object menu. to Reorganize 3D View Menus: View, Add and Object Menu.Nov 24 2015, 2:37 PM
Julian Eisel (Severin) updated the task description. (Show Details)
Julian Eisel (Severin) changed Type from Patch to Design.

Since I usually don't have Blender open for more than a few seconds, we need some users to test and give feedback on this. It can be easily tested by replacing the space_view3d.py in [blender_build_dir]/[release_version]/scripts/startup/bl_ui with the one attached in the task description.

I tested it and find it an overall improvement over the existing menus (to the point I'm keeping it from now on :) It's indeed compact and easier to navigate, especially when you're no longer greeted by a long list of options and have to scan through them to find what you're after. I also like the add menu, somehow it's easier to navigate despite only a few layout changes.

From what I can tell, there don't seem to be any entries missing, just a different layout.

One thing that I'd tweak is the name of the relations submenu in the object menu. "Relations" sounds like a parent-child relationship, whereas the menu holds operators that deal with linking and transfering data (if you read tooltips of the entries many include the word "linked"). So something with data/transfer/linked. Link and transfer data perhaps?

Good job though, thanks for the script!

On question I have is why is Add camera put into a sub menu when there is only one type of camera. As with outlining you should not have sub point with just one point under it e.g.

Correct:

  • Thing 1
    • Sub thing 1
    • Sub thing 2
  • Thing 2
    • Sub thing 1
    • Sub thing 2

Incorrect:

  • Thing 1
    • Sub thing 1
  • Thing 2
    • Sub thing 1

Other then that LGTM

This may be a little off topic but why are there game options even when I am not in game engine mode. There are other examples in headers in Blender that are only available in the game engine why are we inconstant in the UI here?

hi,
@Aaron Carlisle (Blendify) The add camera change to menu item is similar behavior to add armature. The single menu item allows for addons to expand this as a sub menu. An example or this is the Rigify addon which uses the add armature. Similarly in contrib the surround cameras addon could use this expanded menu.

@Matjaž Lamut (lamoot) yes, there's no going back once you use the new menu's, they are designed with the Blender user in mind. Thanks. your right about the use of Relations maybe Link/Transfer would be better. I think it is.

Keep in mind this is just a small section of what needs fixing, Edit Mode entries are far more challenging.

Nice!

I really like the Add Menu. Icons that make more sense are always good. For 'Force Field" I'd change it to "FORCE_FORCE", since it looks like now it's using the particle strand select mode (better than the current Empty icon anyway).

I particularly like the fact that you're adding 'Camera' as its own menu, this will encourage users and developers to make more Camera types.

The addition of Quick Effects to the Add Menu will blow some minds! I know of people that still are not familiar with that feature.

Agree with the point @Aaron Carlisle (Blendify) makes about 'Relations', it feels more like Parent/Child. Besides that, the patch looks good to me.

This will essentially make lots of documentation and tutorials incompatible, so I assume this is for the 2.8 branch?

Note that adding a camera can show as a sub menu once its extended, see: P302

Calling it linked and transfer data seems a bit long of a name to me.

hi, thanks very much for input. There's very valid suggestions that I will take into account when I update the task shortly.

@Aaron Carlisle (Blendify) thanks for writing the patch, I'm really not good with them.
@Pablo Vazquez (venomgfx) thanks, your point is taken about documentation changes. I think the changes are logical enough that people will not get very lost or adapt quickly.
One consideration here is to introduce these menu changes sooner, rather than later. When the 2.8 redesign starts I think it would be good to have most menu restructuring done first, then build the new features on top.
@Campbell Barton (campbellbarton) thanks for P302, If you could commit this I could use right away and make updated patch.

Thanks again, I'll update the patch with everyone's suggestions within the next few days.

updated to fix mentioned issues.
file:

Proposed Changes

View menu === (unchanged from original patch)

  1. Merge base directional numpad operators: Top, Bottom, Front, Back, Left, Right into new menu: "Directions"
  2. Remove duplicate Camera menu enty(numpad 0)
  3. Merge border operators: Render, Zoom, Clipping into new menu: "Set Border"
  4. Merge view toggle Fullscreen, maximize & Quad views into new menu: "View Toggle"
  5. Re-organize layout

3D View: Add Menu

  1. "Camera" move from direct operator to menu: Camera.
  2. Move "Quick Effects menu" from Object Menu to Add menu.
  3. Re-organize layout
  4. Change Icons

Object Menu

  1. Move "Quick Effects menu" from Object Menu to Add menu.
  2. Merge transfer mesh data, make local, make single user, make proxy, make dupliface into new menu: "Object Data"
  3. Move Duplicate object & duplicate linked to new menu: "Duplicate"
  4. Re-organize layout

thanks for feedback.

Clear and well organized. Good job. :)

Like this a lot - it's a lot like before but different enough to constitute a genuinely useful improvement. Top stuff!

Nice work. Much cleaner and easier to scan through.

There is an increased number of clicks needed to get to some operations, but IMO this isn't a problem. If you use an option often enough, the keyboard shortcut is the way to go. This proposal looks better for new users.

Seems this is ready for review from the UI design team?

@Campbell Barton (campbellbarton)
updated patch is here https://developer.blender.org/D1741 thanks to Blendify
I am always available in irc to discuss & help with this patch.
I would hope this could be reviewed shortly after 2.77 release.
Thanks to everyone for feedback & positive comments,

This looks good to me @Brendon Murphy (meta-androcto). The latest revision is a very good improvement on 2.76, and the updates for Object Data in place of Relations is much clearer to me as well.

Commit at will, now that Git is reopened after 2.77.

My review:

I like most of it, but I wouldn't group the View directions. That's because these are pretty important, and need quick access IMO. I suspect many people use the menu instead of the numpad or a pie. Also, the View menu isn't overflowing anyway, so there is no pressing need to bundle them up into Directions.

I'm still a bit wary of applying this for 2.7x. As @Pablo Vazquez (venomgfx) said earlier, this will make many tutorials, manuals, etc. obsolete, which is still an important point. Actually I think this could go into 2.8 master branch right away (still didn't check code details though).

hi,
@Jonathan Williamson (carter2422) thanks so much. I'll wait until UI Team meeting to discuss final concerns before any commit, primary concern it tutorial writers, I feel this patch will have minimal impact. I would appreciate your thoughts on this. Thanks again.
@Paweł Łyczkowski (plyczkowski), the Directions menu merges 6 menu items into 1 easily discover-able menu, for menu user's there's a significant speed up once accustomed to this. For new users they are given easy to understand "Directions" sub-menu, rather than wall of menu entries. For Addons & Pie menu's there's the benefit of just calling the menu. all sub-menu items are not changed so they are unaffected.
@Julian Eisel (Severin), @Pablo Vazquez (venomgfx) I understand your concerns, the workflow in general has not changed, everything is readable & understandable enough that even new users should have little trouble following older tutorials.

Please note: I am trying here to make changes to the ui that are tidy, clean, & consolidate the structure we already have. The changes prepare the ui code & the users for future changes. Incremental restructuring of menu;s should be done sooner, rather than later. The benefits for users are to prepare them for change, the benefits for developers is they can build upon the new menu structures & the over all impact of 2.8 is somewhat lessened for everyone.

Sounds good @Brendon Murphy (meta-androcto). I see no issue with waiting 'til 2.8 for merging.

As a tutorial author myself, this is a pretty minor change and I don't believe that's a strong enough argument to hold off on committing (but also not a reason to rush it in, of course). The manual changes are more of a concern, though, and gives more validity to push for 2.8.

Hi, resolution at UI team Meeting was to apply this patch to 2.8 branch when it's available.
I'll leave this open as it will need updates until that time.
Thanks to UI Team for help & feedback.

I don't think the manual will be a big issue for me or anyone else to mannage.

Added link to the file via my github in the first post. The file will be maintained & updated there.
Updated to 2.77

hi, it's quite surreal that this is already 1 year old.
currently i've rewritten the original patch for 2.79 after.
also written new edit modes 'w' key, v/e/f menus,
new space info header,
new file menu,
compact the node editor,
various ui tweaks
new patches to follow soon.
thanks.

Ok, I've been working on Fracture Modifier speed of workflow improvements. So I've been spending a lot of time in blender. I've also kept in regular contact with Meta on this subject.

I am convinced now more than ever because of my huge number of repetitions in the menu system that this specific topic needs to be addressed and not suffer the oft accused slow death of neglect.

I have repeatedly over the course of the last few weeks shook my head in frustration at the current menu setup. And after just discussing this with Meta just minutes ago and seeing the screen shots again with my current context I am convinced this type of change, if not this exact change, needs to happen for 2.8.

I and many others have worked hard at helping blender shed it's little toy image. This change is one of the things that contributes to blender putting on its big boy pants. Aside from the politics and mechanisms of the "UI Mafia" as we affectionately call it and fulfilling any requirements there, the UI team and responsible devs would be silly not to make this a priority, IMO as a professionally experienced UI/UX developer.

Thanks for letting me spin the squeaky wheel, hopefully it will make a difference.

It seems the conclusion was that it's ok to commit this to the Blender 2.8 branch, and @Brendon Murphy (meta-androcto) has commit rights for that as far as I can tell. So I'm not sure what this is waiting on?

@Brecht Van Lommel (brecht)
i guess waiting on me then, i'll update and port the parch over to 2.8 and submit new diff.
I would be very happy to go ahead with this next week.
thanks


Current file based off 2.79 master.

File for 2.8 to follow and update to task images


this second file includes shorter w key edit mode menu and vert edge face menu redesign

just an update that we are still working on some code cleanup before commit to master.
thanks

  • Cleanup version.
  • Slight adjustments of the menus entries here and there.
  • Make the delete options always separated in menus and more consistent in locations.
  • Try to separate longer blocks of entries.
  • Fix some duplicated separators.

@Vuk Gardašević (lijenstina) is this the "final" version ready for review?

@Aaron Carlisle (Blendify) @Julian Eisel (Severin) yes, this is final version for this round of changes. (other menus may follow)

Campbell Barton (campbellbarton) lowered the priority of this task from Normal to Incomplete.EditedOct 9 2017, 5:08 AM

Apparently this is ready for review but the link: https://github.com/meta-androcto/blenderpython/raw/master/scripts/startup/bl_ui/space_view3d.py is giving me a 404.

Or are you referring to this post T46853#464607 ?

Would rather this go via differential, people uploading files in different places is too haphazard, its also not clear what differences are intended, since some changes have probably been made in master since.

Brendon Murphy (meta-androcto) raised the priority of this task from Incomplete to Normal.Oct 11 2017, 9:02 AM

new diff in first comment at bottom of updated description

Applied most of the changes to the "View" menu, but have some concerns with other changes.

See: D2876#67809


Note, there are 3 places this patch has been discussed.

D2876, D1741 & this task. Closing all except for D2876 since this gets confusing.